/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.237 Revision 1.420
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.237 2006/06/04 15:18:12 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.420 2013/05/21 14:05:31 mgorny Exp $
4#
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9 4
10inherit multilib portability 5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
11 17
12DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
13RDEPEND="" 19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
14# sys-apps/shadow is needed for useradd, etc, bug #94745.
15 20
16DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
17 22
18# Wait for the supplied number of seconds. If no argument is supplied, defaults 23if has "${EAPI:-0}" 0 1 2; then
19# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 24
20# outputting to a terminal, don't wait. For compatability purposes, the argument 25# @FUNCTION: epause
21# must be an integer greater than zero. 26# @USAGE: [seconds]
22# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
23epause() { 32epause() {
24 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
25 sleep ${1:-5}
26 fi
27} 34}
28 35
29# Beep the specified number of times (defaults to five). If our output 36# @FUNCTION: ebeep
30# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 37# @USAGE: [number of beeps]
31# don't beep. 38# @DESCRIPTION:
32# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
33ebeep() { 43ebeep() {
34 local n 44 local n
35 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
36 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
37 echo -ne "\a" 47 echo -ne "\a"
38 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
39 echo -ne "\a" 49 echo -ne "\a"
40 sleep 1 50 sleep 1
41 done 51 done
42 fi 52 fi
43} 53}
44 54
45# This function generate linker scripts in /usr/lib for dynamic 55else
46# libs in /lib. This is to fix linking problems when you have
47# the .so in /lib, and the .a in /usr/lib. What happens is that
48# in some cases when linking dynamic, the .a in /usr/lib is used
49# instead of the .so in /lib due to gcc/libtool tweaking ld's
50# library search path. This cause many builds to fail.
51# See bug #4411 for more info.
52#
53# To use, simply call:
54#
55# gen_usr_ldscript libfoo.so
56#
57# Note that you should in general use the unversioned name of
58# the library, as ldconfig should usually update it correctly
59# to point to the latest version of the library present.
60#
61# <azarah@gentoo.org> (26 Oct 2002)
62#
63gen_usr_ldscript() {
64 local lib libdir=$(get_libdir)
65 # Just make sure it exists
66 dodir /usr/${libdir}
67 56
68 for lib in "${@}" ; do 57ebeep() {
69 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
70 /* GNU ld script 59}
71 Since Gentoo has critical dynamic libraries
72 in /lib, and the static versions in /usr/lib,
73 we need to have a "fake" dynamic lib in /usr/lib,
74 otherwise we run into linking problems.
75 60
76 See bug http://bugs.gentoo.org/4411 for more info. 61epause() {
77 */ 62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
78 GROUP ( /${libdir}/${lib} ) 63}
79 END_LDSCRIPT 64
80 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
81 done 113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
82} 119}
83 120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
84 129
85# Default directory where patches are located 130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: eshopts_push
150# @USAGE: [options to `set` or `shopt`]
151# @DESCRIPTION:
152# Often times code will want to enable a shell option to change code behavior.
153# Since changing shell options can easily break other pieces of code (which
154# assume the default state), eshopts_push is used to (1) push the current shell
155# options onto a stack and (2) pass the specified arguments to set.
156#
157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
159#
160# A common example is to disable shell globbing so that special meaning/care
161# may be used with variables/arguments to custom functions. That would be:
162# @CODE
163# eshopts_push -s noglob
164# for x in ${foo} ; do
165# if ...some check... ; then
166# eshopts_pop
167# return 0
168# fi
169# done
170# eshopts_pop
171# @CODE
172eshopts_push() {
173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
182}
183
184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
86EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
87# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
88EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
89# Default options for patch 229# @VARIABLE: EPATCH_OPTS
230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
90# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
91# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 242# --no-backup-if-mismatch - do not leave .orig files behind
92# Set -E to automatically remove empty files. 243# -E - automatically remove empty files
244# @CODE
93EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
95# and not the full path .. 249# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
97# Change the printed message for a single patch. 253# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
255# @VARIABLE: EPATCH_MULTI_MSG
256# @DESCRIPTION:
99# Change the printed message for multiple patches. 257# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 259# @VARIABLE: EPATCH_FORCE
102# 260# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 261# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 262# arch naming style.
105EPATCH_FORCE="no" 263EPATCH_FORCE="no"
264# @VARIABLE: EPATCH_USER_EXCLUDE
265# @DEFAULT_UNSET
266# @DESCRIPTION:
267# List of patches not to apply. Note this is only file names,
268# and not the full path. Globs accepted.
106 269
107# This function is for bulk patching, or in theory for just one 270# @FUNCTION: epatch
108# or two patches. 271# @USAGE: [options] [patches] [dirs of patches]
272# @DESCRIPTION:
273# epatch is designed to greatly simplify the application of patches. It can
274# process patch files directly, or directories of patches. The patches may be
275# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
276# the -p option as epatch will automatically attempt -p0 to -p5 until things
277# apply successfully.
109# 278#
110# It should work with .bz2, .gz, .zip and plain text patches. 279# If you do not specify any patches/dirs, then epatch will default to the
111# Currently all patches should be the same format. 280# directory specified by EPATCH_SOURCE.
112# 281#
113# You do not have to specify '-p' option to patch, as it will 282# Any options specified that start with a dash will be passed down to patch
114# try with -p0 to -p5 until it succeed, or fail at -p5. 283# for this specific invocation. As soon as an arg w/out a dash is found, then
284# arg processing stops.
115# 285#
116# Above EPATCH_* variables can be used to control various defaults, 286# When processing directories, epatch will apply all patches that match:
117# bug they should be left as is to ensure an ebuild can rely on 287# @CODE
118# them for. 288# if ${EPATCH_FORCE} != "yes"
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 289# ??_${ARCH}_foo.${EPATCH_SUFFIX}
290# else
291# *.${EPATCH_SUFFIX}
292# @CODE
293# The leading ?? are typically numbers used to force consistent patch ordering.
294# The arch field is used to apply patches only for the host architecture with
295# the special value of "all" means apply for everyone. Note that using values
296# other than "all" is highly discouraged -- you should apply patches all the
297# time and let architecture details be detected at configure/compile time.
125# 298#
126# For example: 299# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
300# for patches to apply.
127# 301#
128# 01_all_misc-fix.patch.bz2 302# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 303epatch() {
141 _epatch_draw_line() { 304 _epatch_draw_line() {
305 # create a line of same length as input string
142 [[ -z $1 ]] && set "$(printf "%65s" '')" 306 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 echo "${1//?/=}" 307 echo "${1//?/=}"
144 } 308 }
145 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
146 local PIPE_CMD=""
147 local STDERR_TARGET="${T}/$$.out"
148 local PATCH_TARGET="${T}/$$.patch"
149 local PATCH_SUFFIX=""
150 local SINGLE_PATCH="no"
151 local x=""
152 309
153 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 310 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
154 311
155 if [ "$#" -gt 1 ] 312 # First process options. We localize the EPATCH_OPTS setting
156 then 313 # from above so that we can pass it on in the loop below with
314 # any additional values the user has specified.
315 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
316 while [[ $# -gt 0 ]] ; do
317 case $1 in
318 -*) EPATCH_OPTS+=( "$1" ) ;;
319 *) break ;;
320 esac
321 shift
322 done
323
324 # Let the rest of the code process one user arg at a time --
325 # each arg may expand into multiple patches, and each arg may
326 # need to start off with the default global EPATCH_xxx values
327 if [[ $# -gt 1 ]] ; then
157 local m="" 328 local m
158 for m in "$@" ; do 329 for m in "$@" ; do
159 epatch "${m}" 330 epatch "${m}"
160 done 331 done
161 return 0 332 return 0
162 fi 333 fi
163 334
164 if [ -n "$1" -a -f "$1" ] 335 local SINGLE_PATCH="no"
165 then 336 # no args means process ${EPATCH_SOURCE}
337 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
338
339 if [[ -f $1 ]] ; then
166 SINGLE_PATCH="yes" 340 SINGLE_PATCH="yes"
167 341 set -- "$1"
168 local EPATCH_SOURCE="$1" 342 # Use the suffix from the single patch (localize it); the code
343 # below will find the suffix for us
169 local EPATCH_SUFFIX="${1##*\.}" 344 local EPATCH_SUFFIX=$1
170 345
171 elif [ -n "$1" -a -d "$1" ] 346 elif [[ -d $1 ]] ; then
172 then 347 # Some people like to make dirs of patches w/out suffixes (vim)
173 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 348 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
174 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 349
350 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
351 # Re-use EPATCH_SOURCE as a search dir
352 epatch "${EPATCH_SOURCE}/$1"
353 return $?
354
355 else
356 # sanity check ... if it isn't a dir or file, wtf man ?
357 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
358 echo
359 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
360 eerror
361 eerror " ${EPATCH_SOURCE}"
362 eerror " ( ${EPATCH_SOURCE##*/} )"
363 echo
364 die "Cannot find \$EPATCH_SOURCE!"
365 fi
366
367 # Now that we know we're actually going to apply something, merge
368 # all of the patch options back in to a single variable for below.
369 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
370
371 local PIPE_CMD
372 case ${EPATCH_SUFFIX##*\.} in
373 xz) PIPE_CMD="xz -dc" ;;
374 lzma) PIPE_CMD="lzma -dc" ;;
375 bz2) PIPE_CMD="bzip2 -dc" ;;
376 gz|Z|z) PIPE_CMD="gzip -dc" ;;
377 ZIP|zip) PIPE_CMD="unzip -p" ;;
378 *) ;;
379 esac
380
381 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
382
383 local x
384 for x in "$@" ; do
385 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
386 # didn't match anything, ignore continue on
387 [[ ! -f ${x} ]] && continue
388
389 local patchname=${x##*/}
390
391 # Apply single patches, or forced sets of patches, or
392 # patches with ARCH dependant names.
393 # ???_arch_foo.patch
394 # Else, skip this input altogether
395 local a=${patchname#*_} # strip the ???_
396 a=${a%%_*} # strip the _foo.patch
397 if ! [[ ${SINGLE_PATCH} == "yes" || \
398 ${EPATCH_FORCE} == "yes" || \
399 ${a} == all || \
400 ${a} == ${ARCH} ]]
175 then 401 then
176 local EPATCH_SOURCE="$1/*" 402 continue
403 fi
404
405 # Let people filter things dynamically
406 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
407 # let people use globs in the exclude
408 eshopts_push -o noglob
409
410 local ex
411 for ex in ${EPATCH_EXCLUDE} ; do
412 if [[ ${patchname} == ${ex} ]] ; then
413 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
414 eshopts_pop
415 continue 2
416 fi
417 done
418
419 for ex in ${EPATCH_USER_EXCLUDE} ; do
420 if [[ ${patchname} == ${ex} ]] ; then
421 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
422 eshopts_pop
423 continue 2
424 fi
425 done
426
427 eshopts_pop
428 fi
429
430 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
431 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
432 einfo "${EPATCH_SINGLE_MSG}"
433 else
434 einfo "Applying ${patchname} ..."
435 fi
177 else 436 else
178 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 437 einfo " ${patchname} ..."
179 fi 438 fi
180 else 439
181 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 440 # most of the time, there will only be one run per unique name,
182 then 441 # but if there are more, make sure we get unique log filenames
183 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 442 local STDERR_TARGET="${T}/${patchname}.out"
184 then 443 if [[ -e ${STDERR_TARGET} ]] ; then
185 EPATCH_SOURCE="$1" 444 STDERR_TARGET="${T}/${patchname}-$$.out"
445 fi
446
447 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
448
449 # Decompress the patch if need be
450 local count=0
451 local PATCH_TARGET
452 if [[ -n ${PIPE_CMD} ]] ; then
453 PATCH_TARGET="${T}/$$.patch"
454 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
455
456 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
457 echo
458 eerror "Could not extract patch!"
459 #die "Could not extract patch!"
460 count=5
461 break
186 fi 462 fi
463 else
464 PATCH_TARGET=${x}
465 fi
187 466
467 # Check for absolute paths in patches. If sandbox is disabled,
468 # people could (accidently) patch files in the root filesystem.
469 # Or trigger other unpleasantries #237667. So disallow -p0 on
470 # such patches.
471 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
472 if [[ -n ${abs_paths} ]] ; then
473 count=1
474 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
475 fi
476 # Similar reason, but with relative paths.
477 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
478 if [[ -n ${rel_paths} ]] ; then
188 echo 479 echo
189 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 480 eerror "Rejected Patch: ${patchname} !"
481 eerror " ( ${PATCH_TARGET} )"
190 eerror 482 eerror
191 eerror " ${EPATCH_SOURCE}" 483 eerror "Your patch uses relative paths '../':"
192 eerror " ( ${EPATCH_SOURCE##*/} )" 484 eerror "${rel_paths}"
193 echo 485 echo
194 die "Cannot find \$EPATCH_SOURCE!" 486 die "you need to fix the relative paths in patch"
195 fi
196
197 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
198 fi 487 fi
199 488
200 case ${EPATCH_SUFFIX##*\.} in 489 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
201 bz2) 490 local patch_cmd
202 PIPE_CMD="bzip2 -dc" 491 # Handle aliased patch command #404447 #461568
203 PATCH_SUFFIX="bz2" 492 local patch="patch"
204 ;; 493 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
205 gz|Z|z) 494 while [[ ${count} -lt 5 ]] ; do
206 PIPE_CMD="gzip -dc" 495 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
207 PATCH_SUFFIX="gz"
208 ;;
209 ZIP|zip)
210 PIPE_CMD="unzip -p"
211 PATCH_SUFFIX="zip"
212 ;;
213 *)
214 PIPE_CMD="cat"
215 PATCH_SUFFIX="patch"
216 ;;
217 esac
218 496
219 if [ "${SINGLE_PATCH}" = "no" ] 497 # Generate some useful debug info ...
220 then 498 (
221 einfo "${EPATCH_MULTI_MSG}" 499 _epatch_draw_line "***** ${patchname} *****"
222 fi 500 echo
223 for x in ${EPATCH_SOURCE} 501 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
224 do 502 echo
225 # New ARCH dependant patch naming scheme ... 503 _epatch_draw_line "***** ${patchname} *****"
226 # 504 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
227 # ???_arch_foo.patch 505 ret=$?
228 # 506 echo
229 if [ -f ${x} ] && \ 507 echo "patch program exited with status ${ret}"
230 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \ 508 exit ${ret}
231 [ "${EPATCH_FORCE}" = "yes" ]) 509 ) >> "${STDERR_TARGET}"
232 then
233 local count=0
234 local popts="${EPATCH_OPTS}"
235 local patchname=${x##*/}
236 510
237 if [ -n "${EPATCH_EXCLUDE}" ] 511 if [ $? -eq 0 ] ; then
238 then 512 (
239 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ] 513 _epatch_draw_line "***** ${patchname} *****"
240 then 514 echo
241 continue 515 echo "ACTUALLY APPLYING ${patchname} ..."
516 echo
517 _epatch_draw_line "***** ${patchname} *****"
518 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
519 ret=$?
520 echo
521 echo "patch program exited with status ${ret}"
522 exit ${ret}
523 ) >> "${STDERR_TARGET}"
524
525 if [ $? -ne 0 ] ; then
526 echo
527 eerror "A dry-run of patch command succeeded, but actually"
528 eerror "applying the patch failed!"
529 #die "Real world sux compared to the dreamworld!"
530 count=5
242 fi 531 fi
532 break
243 fi 533 fi
244 534
245 if [ "${SINGLE_PATCH}" = "yes" ] 535 : $(( count++ ))
246 then
247 if [ -n "${EPATCH_SINGLE_MSG}" ]
248 then
249 einfo "${EPATCH_SINGLE_MSG}"
250 else
251 einfo "Applying ${patchname} ..."
252 fi
253 else
254 einfo " ${patchname} ..."
255 fi
256
257 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
258 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
259
260 # Allow for prefix to differ ... im lazy, so shoot me :/
261 while [ "${count}" -lt 5 ]
262 do
263 # Generate some useful debug info ...
264 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266
267 if [ "${PATCH_SUFFIX}" != "patch" ]
268 then
269 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 else
272 PATCH_TARGET="${x}"
273 fi
274
275 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
277
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280
281 if [ "${PATCH_SUFFIX}" != "patch" ]
282 then
283 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
284 then
285 echo
286 eerror "Could not extract patch!"
287 #die "Could not extract patch!"
288 count=5
289 break
290 fi
291 fi
292
293 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
294 then
295 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
297 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
298 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
299 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300
301 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
302 _epatch_assert
303
304 if [ "$?" -ne 0 ]
305 then
306 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
307 echo
308 eerror "A dry-run of patch command succeeded, but actually"
309 eerror "applying the patch failed!"
310 #die "Real world sux compared to the dreamworld!"
311 count=5
312 fi
313
314 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
315
316 break
317 fi
318
319 count=$((count + 1))
320 done 536 done
321 537
322 if [ "${PATCH_SUFFIX}" != "patch" ] 538 # if we had to decompress the patch, delete the temp one
323 then 539 if [[ -n ${PIPE_CMD} ]] ; then
324 rm -f ${PATCH_TARGET} 540 rm -f "${PATCH_TARGET}"
325 fi 541 fi
326 542
327 if [ "${count}" -eq 5 ] 543 if [[ ${count} -ge 5 ]] ; then
328 then
329 echo 544 echo
330 eerror "Failed Patch: ${patchname} !" 545 eerror "Failed Patch: ${patchname} !"
331 eerror " ( ${PATCH_TARGET} )" 546 eerror " ( ${PATCH_TARGET} )"
332 eerror 547 eerror
333 eerror "Include in your bugreport the contents of:" 548 eerror "Include in your bugreport the contents of:"
334 eerror 549 eerror
335 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}" 550 eerror " ${STDERR_TARGET}"
336 echo 551 echo
337 die "Failed Patch: ${patchname}!" 552 die "Failed Patch: ${patchname}!"
338 fi 553 fi
339 554
340 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 555 # if everything worked, delete the full debug patch log
556 rm -f "${STDERR_TARGET}"
341 557
558 # then log away the exact stuff for people to review later
559 cat <<-EOF >> "${T}/epatch.log"
560 PATCH: ${x}
561 CMD: ${patch_cmd}
562 PWD: ${PWD}
563
564 EOF
342 eend 0 565 eend 0
343 fi
344 done 566 done
345 if [ "${SINGLE_PATCH}" = "no" ] 567
346 then 568 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
347 einfo "Done with patching" 569 : # everything worked
570}
571
572# @FUNCTION: epatch_user
573# @USAGE:
574# @DESCRIPTION:
575# Applies user-provided patches to the source tree. The patches are
576# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
577# of these three directories to exist will be the one to use, ignoring
578# any more general directories which might exist as well. They must end
579# in ".patch" to be applied.
580#
581# User patches are intended for quick testing of patches without ebuild
582# modifications, as well as for permanent customizations a user might
583# desire. Obviously, there can be no official support for arbitrarily
584# patched ebuilds. So whenever a build log in a bug report mentions that
585# user patches were applied, the user should be asked to reproduce the
586# problem without these.
587#
588# Not all ebuilds do call this function, so placing patches in the
589# stated directory might or might not work, depending on the package and
590# the eclasses it inherits and uses. It is safe to call the function
591# repeatedly, so it is always possible to add a call at the ebuild
592# level. The first call is the time when the patches will be
593# applied.
594#
595# Ideally, this function should be called after gentoo-specific patches
596# have been applied, so that their code can be modified as well, but
597# before calls to e.g. eautoreconf, as the user patches might affect
598# autotool input files as well.
599epatch_user() {
600 [[ $# -ne 0 ]] && die "epatch_user takes no options"
601
602 # Allow multiple calls to this function; ignore all but the first
603 local applied="${T}/epatch_user.log"
604 [[ -e ${applied} ]] && return 2
605
606 # don't clobber any EPATCH vars that the parent might want
607 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
608 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
609 EPATCH_SOURCE=${base}/${CTARGET}/${check}
610 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
611 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
612 if [[ -d ${EPATCH_SOURCE} ]] ; then
613 EPATCH_SOURCE=${EPATCH_SOURCE} \
614 EPATCH_SUFFIX="patch" \
615 EPATCH_FORCE="yes" \
616 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
617 epatch
618 echo "${EPATCH_SOURCE}" > "${applied}"
619 return 0
348 fi 620 fi
621 done
622 echo "none" > "${applied}"
623 return 1
349} 624}
350 625
626# @FUNCTION: emktemp
627# @USAGE: [temp dir]
628# @DESCRIPTION:
351# Cheap replacement for when debianutils (and thus mktemp) 629# Cheap replacement for when debianutils (and thus mktemp)
352# does not exist on the users system 630# does not exist on the users system.
353# vapier@gentoo.org
354#
355# Takes just 1 optional parameter (the directory to create tmpfile in)
356emktemp() { 631emktemp() {
357 local exe="touch" 632 local exe="touch"
358 [[ $1 == -d ]] && exe="mkdir" && shift 633 [[ $1 == -d ]] && exe="mkdir" && shift
359 local topdir=$1 634 local topdir=$1
360 635
362 [[ -z ${T} ]] \ 637 [[ -z ${T} ]] \
363 && topdir="/tmp" \ 638 && topdir="/tmp" \
364 || topdir=${T} 639 || topdir=${T}
365 fi 640 fi
366 641
367 if [[ -z $(type -p mktemp) ]] ; then 642 if ! type -P mktemp > /dev/null ; then
643 # system lacks `mktemp` so we have to fake it
368 local tmp=/ 644 local tmp=/
369 while [[ -e ${tmp} ]] ; do 645 while [[ -e ${tmp} ]] ; do
370 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 646 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
371 done 647 done
372 ${exe} "${tmp}" || ${exe} -p "${tmp}" 648 ${exe} "${tmp}" || ${exe} -p "${tmp}"
373 echo "${tmp}" 649 echo "${tmp}"
374 else 650 else
651 # the args here will give slightly wierd names on BSD,
652 # but should produce a usable file on all userlands
375 if [[ ${exe} == "touch" ]] ; then 653 if [[ ${exe} == "touch" ]] ; then
376 [[ ${USERLAND} == "GNU" ]] \
377 && mktemp -p "${topdir}" \
378 || TMPDIR="${topdir}" mktemp -t tmp 654 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
379 else 655 else
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -d "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -dt tmp 656 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
383 fi
384 fi
385}
386
387# Small wrapper for getent (Linux), nidump (Mac OS X),
388# and pw (FreeBSD) used in enewuser()/enewgroup()
389# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
390# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
391#
392# egetent(database, key)
393egetent() {
394 case ${CHOST} in
395 *-darwin*)
396 case "$2" in
397 *[!0-9]*) # Non numeric
398 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
399 ;;
400 *) # Numeric
401 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
402 ;;
403 esac
404 ;;
405 *-freebsd*|*-dragonfly*)
406 local opts action="user"
407 [[ $1 == "passwd" ]] || action="group"
408
409 # lookup by uid/gid
410 if [[ $2 == [[:digit:]]* ]] ; then
411 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
412 fi
413
414 pw show ${action} ${opts} "$2" -q
415 ;;
416 *-netbsd*|*-openbsd*)
417 grep "$2:\*:" /etc/$1
418 ;;
419 *)
420 type -p nscd >& /dev/null && nscd -i "$1"
421 getent "$1" "$2"
422 ;;
423 esac
424}
425
426# Simplify/standardize adding users to the system
427# vapier@gentoo.org
428#
429# enewuser(username, uid, shell, homedir, groups, extra options)
430#
431# Default values if you do not specify any:
432# username: REQUIRED !
433# uid: next available (see useradd(8))
434# note: pass -1 to get default behavior
435# shell: /bin/false
436# homedir: /dev/null
437# groups: none
438# extra: comment of 'added by portage for ${PN}'
439enewuser() {
440 case ${EBUILD_PHASE} in
441 unpack|compile|test|install)
442 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
443 eerror "Package fails at QA and at life. Please file a bug."
444 die "Bad package! enewuser is only for use in pkg_* functions!"
445 esac
446
447 # get the username
448 local euser=$1; shift
449 if [[ -z ${euser} ]] ; then
450 eerror "No username specified !"
451 die "Cannot call enewuser without a username"
452 fi
453
454 # lets see if the username already exists
455 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
456 return 0
457 fi
458 einfo "Adding user '${euser}' to your system ..."
459
460 # options to pass to useradd
461 local opts=
462
463 # handle uid
464 local euid=$1; shift
465 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
466 if [[ ${euid} -gt 0 ]] ; then
467 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
468 euid="next"
469 fi 657 fi
470 else
471 eerror "Userid given but is not greater than 0 !"
472 die "${euid} is not a valid UID"
473 fi 658 fi
474 else
475 euid="next"
476 fi
477 if [[ ${euid} == "next" ]] ; then
478 for euid in $(seq 101 999) ; do
479 [[ -z $(egetent passwd ${euid}) ]] && break
480 done
481 fi
482 opts="${opts} -u ${euid}"
483 einfo " - Userid: ${euid}"
484
485 # handle shell
486 local eshell=$1; shift
487 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
488 if [[ ! -e ${ROOT}${eshell} ]] ; then
489 eerror "A shell was specified but it does not exist !"
490 die "${eshell} does not exist in ${ROOT}"
491 fi
492 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
493 eerror "Do not specify ${eshell} yourself, use -1"
494 die "Pass '-1' as the shell parameter"
495 fi
496 else
497 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
498 [[ -x ${ROOT}${shell} ]] && break
499 done
500
501 if [[ ${shell} == "/dev/null" ]] ; then
502 eerror "Unable to identify the shell to use"
503 die "Unable to identify the shell to use"
504 fi
505
506 eshell=${shell}
507 fi
508 einfo " - Shell: ${eshell}"
509 opts="${opts} -s ${eshell}"
510
511 # handle homedir
512 local ehome=$1; shift
513 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
514 ehome="/dev/null"
515 fi
516 einfo " - Home: ${ehome}"
517 opts="${opts} -d ${ehome}"
518
519 # handle groups
520 local egroups=$1; shift
521 if [[ ! -z ${egroups} ]] ; then
522 local oldifs=${IFS}
523 local defgroup="" exgroups=""
524
525 export IFS=","
526 for g in ${egroups} ; do
527 export IFS=${oldifs}
528 if [[ -z $(egetent group "${g}") ]] ; then
529 eerror "You must add group ${g} to the system first"
530 die "${g} is not a valid GID"
531 fi
532 if [[ -z ${defgroup} ]] ; then
533 defgroup=${g}
534 else
535 exgroups="${exgroups},${g}"
536 fi
537 export IFS=","
538 done
539 export IFS=${oldifs}
540
541 opts="${opts} -g ${defgroup}"
542 if [[ ! -z ${exgroups} ]] ; then
543 opts="${opts} -G ${exgroups:1}"
544 fi
545 else
546 egroups="(none)"
547 fi
548 einfo " - Groups: ${egroups}"
549
550 # handle extra and add the user
551 local oldsandbox=${SANDBOX_ON}
552 export SANDBOX_ON="0"
553 case ${CHOST} in
554 *-darwin*)
555 ### Make the user
556 if [[ -z $@ ]] ; then
557 dscl . create /users/${euser} uid ${euid}
558 dscl . create /users/${euser} shell ${eshell}
559 dscl . create /users/${euser} home ${ehome}
560 dscl . create /users/${euser} realname "added by portage for ${PN}"
561 ### Add the user to the groups specified
562 local oldifs=${IFS}
563 export IFS=","
564 for g in ${egroups} ; do
565 dscl . merge /groups/${g} users ${euser}
566 done
567 export IFS=${oldifs}
568 else
569 einfo "Extra options are not supported on Darwin yet"
570 einfo "Please report the ebuild along with the info below"
571 einfo "eextra: $@"
572 die "Required function missing"
573 fi
574 ;;
575 *-freebsd*|*-dragonfly*)
576 if [[ -z $@ ]] ; then
577 pw useradd ${euser} ${opts} \
578 -c "added by portage for ${PN}" \
579 die "enewuser failed"
580 else
581 einfo " - Extra: $@"
582 pw useradd ${euser} ${opts} \
583 "$@" || die "enewuser failed"
584 fi
585 ;;
586
587 *-netbsd*)
588 if [[ -z $@ ]] ; then
589 useradd ${opts} ${euser} || die "enewuser failed"
590 else
591 einfo " - Extra: $@"
592 useradd ${opts} ${euser} "$@" || die "enewuser failed"
593 fi
594 ;;
595
596 *-openbsd*)
597 if [[ -z $@ ]] ; then
598 useradd -u ${euid} -s ${eshell} \
599 -d ${ehome} -c "Added by portage for ${PN}" \
600 -g ${egroups} ${euser} || die "enewuser failed"
601 else
602 einfo " - Extra: $@"
603 useradd -u ${euid} -s ${eshell} \
604 -d ${ehome} -c "Added by portage for ${PN}" \
605 -g ${egroups} ${euser} "$@" || die "enewuser failed"
606 fi
607 ;;
608
609 *)
610 if [[ -z $@ ]] ; then
611 useradd ${opts} ${euser} \
612 -c "added by portage for ${PN}" \
613 || die "enewuser failed"
614 else
615 einfo " - Extra: $@"
616 useradd ${opts} ${euser} "$@" \
617 || die "enewuser failed"
618 fi
619 ;;
620 esac
621
622 if [[ ! -e ${ROOT}/${ehome} ]] ; then
623 einfo " - Creating ${ehome} in ${ROOT}"
624 mkdir -p "${ROOT}/${ehome}"
625 chown ${euser} "${ROOT}/${ehome}"
626 chmod 755 "${ROOT}/${ehome}"
627 fi
628
629 export SANDBOX_ON=${oldsandbox}
630} 659}
631 660
632# Simplify/standardize adding groups to the system 661# @FUNCTION: edos2unix
633# vapier@gentoo.org 662# @USAGE: <file> [more files ...]
634# 663# @DESCRIPTION:
635# enewgroup(group, gid) 664# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
636# 665# to remove all of these text utilities from DEPEND variables because this
637# Default values if you do not specify any: 666# is a script based solution. Just give it a list of files to convert and
638# groupname: REQUIRED ! 667# they will all be changed from the DOS CRLF format to the UNIX LF format.
639# gid: next available (see groupadd(8))
640# extra: none
641enewgroup() {
642 case ${EBUILD_PHASE} in
643 unpack|compile|test|install)
644 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
645 eerror "Package fails at QA and at life. Please file a bug."
646 die "Bad package! enewgroup is only for use in pkg_* functions!"
647 esac
648
649 # get the group
650 local egroup="$1"; shift
651 if [ -z "${egroup}" ]
652 then
653 eerror "No group specified !"
654 die "Cannot call enewgroup without a group"
655 fi
656
657 # see if group already exists
658 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
659 then
660 return 0
661 fi
662 einfo "Adding group '${egroup}' to your system ..."
663
664 # options to pass to useradd
665 local opts=
666
667 # handle gid
668 local egid="$1"; shift
669 if [ ! -z "${egid}" ]
670 then
671 if [ "${egid}" -gt 0 ]
672 then
673 if [ -z "`egetent group ${egid}`" ]
674 then
675 if [[ "${CHOST}" == *-darwin* ]]; then
676 opts="${opts} ${egid}"
677 else
678 opts="${opts} -g ${egid}"
679 fi
680 else
681 egid="next available; requested gid taken"
682 fi
683 else
684 eerror "Groupid given but is not greater than 0 !"
685 die "${egid} is not a valid GID"
686 fi
687 else
688 egid="next available"
689 fi
690 einfo " - Groupid: ${egid}"
691
692 # handle extra
693 local eextra="$@"
694 opts="${opts} ${eextra}"
695
696 # add the group
697 local oldsandbox="${SANDBOX_ON}"
698 export SANDBOX_ON="0"
699 case ${CHOST} in
700 *-darwin*)
701 if [ ! -z "${eextra}" ];
702 then
703 einfo "Extra options are not supported on Darwin/OS X yet"
704 einfo "Please report the ebuild along with the info below"
705 einfo "eextra: ${eextra}"
706 die "Required function missing"
707 fi
708
709 # If we need the next available
710 case ${egid} in
711 *[!0-9]*) # Non numeric
712 for egid in $(seq 101 999); do
713 [ -z "`egetent group ${egid}`" ] && break
714 done
715 esac
716 dscl . create /groups/${egroup} gid ${egid}
717 dscl . create /groups/${egroup} passwd '*'
718 ;;
719
720 *-freebsd*|*-dragonfly*)
721 case ${egid} in
722 *[!0-9]*) # Non numeric
723 for egid in $(seq 101 999); do
724 [ -z "`egetent group ${egid}`" ] && break
725 done
726 esac
727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
728 ;;
729
730 *-netbsd*)
731 case ${egid} in
732 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do
734 [ -z "`egetent group ${egid}`" ] && break
735 done
736 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;;
739
740 *)
741 groupadd ${opts} ${egroup} || die "enewgroup failed"
742 ;;
743 esac
744 export SANDBOX_ON="${oldsandbox}"
745}
746
747# Simple script to replace 'dos2unix' binaries
748# vapier@gentoo.org
749#
750# edos2unix(file, <more files> ...)
751edos2unix() { 668edos2unix() {
752 for f in "$@" 669 [[ $# -eq 0 ]] && return 0
753 do 670 sed -i 's/\r$//' -- "$@" || die
754 cp "${f}" ${T}/edos2unix
755 sed 's/\r$//' ${T}/edos2unix > "${f}"
756 done
757} 671}
758 672
759 673# @FUNCTION: make_desktop_entry
760############################################################## 674# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
761# START: Handle .desktop files and menu entries # 675# @DESCRIPTION:
762# maybe this should be separated into a new eclass some time #
763# lanius@gentoo.org #
764##############################################################
765
766# Make a desktop file ! 676# Make a .desktop file.
767# Great for making those icons in kde/gnome startmenu !
768# Amaze your friends ! Get the women ! Join today !
769# 677#
770# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 678# @CODE
771#
772# binary: what binary does the app run with ? 679# binary: what command does the app run with ?
773# name: the name that will show up in the menu 680# name: the name that will show up in the menu
774# icon: give your little like a pretty little icon ... 681# icon: the icon to use in the menu entry
775# this can be relative (to /usr/share/pixmaps) or 682# this can be relative (to /usr/share/pixmaps) or
776# a full path to an icon 683# a full path to an icon
777# type: what kind of application is this ? for categories: 684# type: what kind of application is this?
778# http://www.freedesktop.org/Standards/desktop-entry-spec 685# for categories:
779# path: if your app needs to startup in a specific dir 686# http://standards.freedesktop.org/menu-spec/latest/apa.html
687# if unset, function tries to guess from package's category
688# fields: extra fields to append to the desktop file; a printf string
689# @CODE
780make_desktop_entry() { 690make_desktop_entry() {
781 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 691 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
782 692
783 local exec=${1} 693 local exec=${1}
784 local name=${2:-${PN}} 694 local name=${2:-${PN}}
785 local icon=${3:-${PN}.png} 695 local icon=${3:-${PN}}
786 local type=${4} 696 local type=${4}
787 local path=${5} 697 local fields=${5}
788 698
789 if [[ -z ${type} ]] ; then 699 if [[ -z ${type} ]] ; then
790 local catmaj=${CATEGORY%%-*} 700 local catmaj=${CATEGORY%%-*}
791 local catmin=${CATEGORY##*-} 701 local catmin=${CATEGORY##*-}
792 case ${catmaj} in 702 case ${catmaj} in
793 app) 703 app)
794 case ${catmin} in 704 case ${catmin} in
705 accessibility) type="Utility;Accessibility";;
795 admin) type=System;; 706 admin) type=System;;
707 antivirus) type=System;;
708 arch) type="Utility;Archiving";;
709 backup) type="Utility;Archiving";;
796 cdr) type=DiscBurning;; 710 cdr) type="AudioVideo;DiscBurning";;
797 dicts) type=Dictionary;; 711 dicts) type="Office;Dictionary";;
712 doc) type=Documentation;;
798 editors) type=TextEditor;; 713 editors) type="Utility;TextEditor";;
799 emacs) type=TextEditor;; 714 emacs) type="Development;TextEditor";;
800 emulation) type=Emulator;; 715 emulation) type="System;Emulator";;
801 laptop) type=HardwareSettings;; 716 laptop) type="Settings;HardwareSettings";;
802 office) type=Office;; 717 office) type=Office;;
718 pda) type="Office;PDA";;
803 vim) type=TextEditor;; 719 vim) type="Development;TextEditor";;
804 xemacs) type=TextEditor;; 720 xemacs) type="Development;TextEditor";;
805 *) type=;;
806 esac 721 esac
807 ;; 722 ;;
808 723
809 dev) 724 dev)
810 type="Development" 725 type="Development"
811 ;; 726 ;;
812 727
813 games) 728 games)
814 case ${catmin} in 729 case ${catmin} in
815 action) type=ActionGame;; 730 action|fps) type=ActionGame;;
816 arcade) type=ArcadeGame;; 731 arcade) type=ArcadeGame;;
817 board) type=BoardGame;; 732 board) type=BoardGame;;
818 kid) type=KidsGame;;
819 emulation) type=Emulator;; 733 emulation) type=Emulator;;
734 kids) type=KidsGame;;
820 puzzle) type=LogicGame;; 735 puzzle) type=LogicGame;;
736 roguelike) type=RolePlaying;;
821 rpg) type=RolePlaying;; 737 rpg) type=RolePlaying;;
822 roguelike) type=RolePlaying;;
823 simulation) type=Simulation;; 738 simulation) type=Simulation;;
824 sports) type=SportsGame;; 739 sports) type=SportsGame;;
825 strategy) type=StrategyGame;; 740 strategy) type=StrategyGame;;
826 *) type=;;
827 esac 741 esac
828 type="Game;${type}" 742 type="Game;${type}"
829 ;; 743 ;;
830 744
745 gnome)
746 type="Gnome;GTK"
747 ;;
748
749 kde)
750 type="KDE;Qt"
751 ;;
752
831 mail) 753 mail)
832 type="Network;Email" 754 type="Network;Email"
833 ;; 755 ;;
834 756
835 media) 757 media)
836 case ${catmin} in 758 case ${catmin} in
759 gfx)
837 gfx) type=Graphics;; 760 type=Graphics
761 ;;
762 *)
763 case ${catmin} in
838 radio) type=Tuner;; 764 radio) type=Tuner;;
839 sound) type=Audio;; 765 sound) type=Audio;;
840 tv) type=TV;; 766 tv) type=TV;;
841 video) type=Video;; 767 video) type=Video;;
842 *) type=;; 768 esac
769 type="AudioVideo;${type}"
770 ;;
843 esac 771 esac
844 type="AudioVideo;${type}"
845 ;; 772 ;;
846 773
847 net) 774 net)
848 case ${catmin} in 775 case ${catmin} in
849 dialup) type=Dialup;; 776 dialup) type=Dialup;;
852 irc) type=IRCClient;; 779 irc) type=IRCClient;;
853 mail) type=Email;; 780 mail) type=Email;;
854 news) type=News;; 781 news) type=News;;
855 nntp) type=News;; 782 nntp) type=News;;
856 p2p) type=FileTransfer;; 783 p2p) type=FileTransfer;;
857 *) type=;; 784 voip) type=Telephony;;
858 esac 785 esac
859 type="Network;${type}" 786 type="Network;${type}"
860 ;; 787 ;;
861 788
862 sci) 789 sci)
863 case ${catmin} in 790 case ${catmin} in
864 astro*) type=Astronomy;; 791 astro*) type=Astronomy;;
865 bio*) type=Biology;; 792 bio*) type=Biology;;
866 calc*) type=Calculator;; 793 calc*) type=Calculator;;
867 chem*) type=Chemistry;; 794 chem*) type=Chemistry;;
795 elec*) type=Electronics;;
868 geo*) type=Geology;; 796 geo*) type=Geology;;
869 math*) type=Math;; 797 math*) type=Math;;
870 *) type=;; 798 physics) type=Physics;;
799 visual*) type=DataVisualization;;
871 esac 800 esac
872 type="Science;${type}" 801 type="Education;Science;${type}"
802 ;;
803
804 sys)
805 type="System"
873 ;; 806 ;;
874 807
875 www) 808 www)
876 case ${catmin} in 809 case ${catmin} in
877 client) type=WebBrowser;; 810 client) type=WebBrowser;;
878 *) type=;;
879 esac 811 esac
880 type="Network" 812 type="Network;${type}"
881 ;; 813 ;;
882 814
883 *) 815 *)
884 type= 816 type=
885 ;; 817 ;;
888 if [ "${SLOT}" == "0" ] ; then 820 if [ "${SLOT}" == "0" ] ; then
889 local desktop_name="${PN}" 821 local desktop_name="${PN}"
890 else 822 else
891 local desktop_name="${PN}-${SLOT}" 823 local desktop_name="${PN}-${SLOT}"
892 fi 824 fi
893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 825 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 826 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 827
828 # Don't append another ";" when a valid category value is provided.
829 type=${type%;}${type:+;}
830
831 eshopts_push -s extglob
832 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
833 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
834 ewarn "allowed in .desktop files if the value is not an absolute path."
835 icon=${icon%.@(xpm|png|svg)}
836 fi
837 eshopts_pop
838
839 cat <<-EOF > "${desktop}"
896echo "[Desktop Entry] 840 [Desktop Entry]
897Encoding=UTF-8
898Version=0.9.2
899Name=${name} 841 Name=${name}
900Type=Application 842 Type=Application
901Comment=${DESCRIPTION} 843 Comment=${DESCRIPTION}
902Exec=${exec} 844 Exec=${exec}
903TryExec=${exec} 845 TryExec=${exec%% *}
904Path=${path}
905Icon=${icon} 846 Icon=${icon}
906Categories=Application;${type};" > "${desktop}" 847 Categories=${type}
848 EOF
849
850 if [[ ${fields:-=} != *=* ]] ; then
851 # 5th arg used to be value to Path=
852 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
853 fields="Path=${fields}"
854 fi
855 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
907 856
908 ( 857 (
909 # wrap the env here so that the 'insinto' call 858 # wrap the env here so that the 'insinto' call
910 # doesn't corrupt the env of the caller 859 # doesn't corrupt the env of the caller
911 insinto /usr/share/applications 860 insinto /usr/share/applications
912 doins "${desktop}" 861 doins "${desktop}"
913 ) 862 ) || die "installing desktop file failed"
914} 863}
915 864
916# Make a GDM/KDM Session file 865# @FUNCTION: validate_desktop_entries
917# 866# @USAGE: [directories]
918# make_desktop_entry(<title>, <command>) 867# @MAINTAINER:
919# title: File to execute to start the Window Manager 868# Carsten Lohrke <carlo@gentoo.org>
920# command: Name of the Window Manager 869# @DESCRIPTION:
870# Validate desktop entries using desktop-file-utils
871validate_desktop_entries() {
872 if [[ -x /usr/bin/desktop-file-validate ]] ; then
873 einfo "Checking desktop entry validity"
874 local directories=""
875 for d in /usr/share/applications $@ ; do
876 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
877 done
878 if [[ -n ${directories} ]] ; then
879 for FILE in $(find ${directories} -name "*\.desktop" \
880 -not -path '*.hidden*' | sort -u 2>/dev/null)
881 do
882 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
883 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
884 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
885 done
886 fi
887 echo ""
888 else
889 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
890 fi
891}
921 892
893# @FUNCTION: make_session_desktop
894# @USAGE: <title> <command> [command args...]
895# @DESCRIPTION:
896# Make a GDM/KDM Session file. The title is the file to execute to start the
897# Window Manager. The command is the name of the Window Manager.
898#
899# You can set the name of the file via the ${wm} variable.
922make_session_desktop() { 900make_session_desktop() {
923 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 901 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
924 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 902 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
925 903
926 local title=$1 904 local title=$1
927 local command=$2 905 local command=$2
928 local desktop=${T}/${wm}.desktop 906 local desktop=${T}/${wm:-${PN}}.desktop
907 shift 2
929 908
909 cat <<-EOF > "${desktop}"
930echo "[Desktop Entry] 910 [Desktop Entry]
931Encoding=UTF-8
932Name=${title} 911 Name=${title}
933Comment=This session logs you into ${title} 912 Comment=This session logs you into ${title}
934Exec=${command} 913 Exec=${command} $*
935TryExec=${command} 914 TryExec=${command}
936Type=Application" > "${desktop}" 915 Type=XSession
916 EOF
937 917
918 (
919 # wrap the env here so that the 'insinto' call
920 # doesn't corrupt the env of the caller
938 insinto /usr/share/xsessions 921 insinto /usr/share/xsessions
939 doins "${desktop}" 922 doins "${desktop}"
923 )
940} 924}
941 925
926# @FUNCTION: domenu
927# @USAGE: <menus>
928# @DESCRIPTION:
929# Install the list of .desktop menu files into the appropriate directory
930# (/usr/share/applications).
942domenu() { 931domenu() {
932 (
933 # wrap the env here so that the 'insinto' call
934 # doesn't corrupt the env of the caller
943 local i j 935 local i j ret=0
944 insinto /usr/share/applications 936 insinto /usr/share/applications
945 for i in "$@" ; do 937 for i in "$@" ; do
946 if [[ -f ${i} ]] ; then 938 if [[ -f ${i} ]] ; then
947 doins "${i}" 939 doins "${i}"
940 ((ret+=$?))
948 elif [[ -d ${i} ]] ; then 941 elif [[ -d ${i} ]] ; then
949 for j in "${i}"/*.desktop ; do 942 for j in "${i}"/*.desktop ; do
950 doins "${j}" 943 doins "${j}"
944 ((ret+=$?))
951 done 945 done
946 else
947 ((++ret))
952 fi 948 fi
953 done 949 done
950 exit ${ret}
951 )
954} 952}
953
954# @FUNCTION: newmenu
955# @USAGE: <menu> <newname>
956# @DESCRIPTION:
957# Like all other new* functions, install the specified menu as newname.
955newmenu() { 958newmenu() {
959 (
960 # wrap the env here so that the 'insinto' call
961 # doesn't corrupt the env of the caller
956 insinto /usr/share/applications 962 insinto /usr/share/applications
957 newins "$1" "$2" 963 newins "$@"
964 )
958} 965}
959 966
960doicon() { 967# @FUNCTION: _iconins
961 local i j 968# @INTERNAL
962 insinto /usr/share/pixmaps 969# @DESCRIPTION:
963 for i in "$@" ; do 970# function for use in doicon and newicon
964 if [[ -f ${i} ]] ; then 971_iconins() {
965 doins "${i}" 972 (
966 elif [[ -d ${i} ]] ; then 973 # wrap the env here so that the 'insinto' call
967 for j in "${i}"/*.png ; do 974 # doesn't corrupt the env of the caller
968 doins "${j}" 975 local funcname=$1; shift
969 done 976 local size dir
970 fi 977 local context=apps
971 done 978 local theme=hicolor
972}
973newicon() {
974 insinto /usr/share/pixmaps
975 newins "$1" "$2"
976}
977 979
978############################################################## 980 while [[ $# -gt 0 ]] ; do
979# END: Handle .desktop files and menu entries # 981 case $1 in
980############################################################## 982 -s|--size)
981 983 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
982 984 size=${2%%x*}
983# for internal use only (unpack_pdv and unpack_makeself)
984find_unpackable_file() {
985 local src=$1
986 if [[ -z ${src} ]] ; then
987 src=${DISTDIR}/${A}
988 else
989 if [[ -e ${DISTDIR}/${src} ]] ; then
990 src=${DISTDIR}/${src}
991 elif [[ -e ${PWD}/${src} ]] ; then
992 src=${PWD}/${src}
993 elif [[ -e ${src} ]] ; then
994 src=${src}
995 fi
996 fi
997 [[ ! -e ${src} ]] && return 1
998 echo "${src}"
999}
1000
1001# Unpack those pesky pdv generated files ...
1002# They're self-unpacking programs with the binary package stuffed in
1003# the middle of the archive. Valve seems to use it a lot ... too bad
1004# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1005#
1006# Usage: unpack_pdv [file to unpack] [size of off_t]
1007# - you have to specify the off_t size ... i have no idea how to extract that
1008# information out of the binary executable myself. basically you pass in
1009# the size of the off_t type (in bytes) on the machine that built the pdv
1010# archive. one way to determine this is by running the following commands:
1011# strings <pdv archive> | grep lseek
1012# strace -elseek <pdv archive>
1013# basically look for the first lseek command (we do the strings/grep because
1014# sometimes the function call is _llseek or something) and steal the 2nd
1015# parameter. here is an example:
1016# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1017# lseek
1018# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1019# lseek(3, -4, SEEK_END) = 2981250
1020# thus we would pass in the value of '4' as the second parameter.
1021unpack_pdv() {
1022 local src=$(find_unpackable_file $1)
1023 local sizeoff_t=$2
1024
1025 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1026 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1027
1028 local shrtsrc=$(basename "${src}")
1029 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1030 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1031 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1032
1033 # grab metadata for debug reasons
1034 local metafile="$(emktemp)"
1035 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1036
1037 # rip out the final file name from the metadata
1038 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1039 datafile="`basename ${datafile}`"
1040
1041 # now lets uncompress/untar the file if need be
1042 local tmpfile="$(emktemp)"
1043 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1044
1045 local iscompressed="`file -b ${tmpfile}`"
1046 if [ "${iscompressed:0:8}" == "compress" ] ; then
1047 iscompressed=1
1048 mv ${tmpfile}{,.Z}
1049 gunzip ${tmpfile}
1050 else
1051 iscompressed=0
1052 fi
1053 local istar="`file -b ${tmpfile}`"
1054 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1055 istar=1
1056 else
1057 istar=0
1058 fi
1059
1060 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1061 #dd if=${src} ibs=${metaskip} count=1 \
1062 # | dd ibs=${tailskip} skip=1 \
1063 # | gzip -dc \
1064 # > ${datafile}
1065 if [ ${iscompressed} -eq 1 ] ; then
1066 if [ ${istar} -eq 1 ] ; then
1067 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1068 | head -c $((${metaskip}-${tailskip})) \
1069 | tar -xzf -
1070 else 985 else
1071 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \ 986 size=${2}
1072 | head -c $((${metaskip}-${tailskip})) \
1073 | gzip -dc \
1074 > ${datafile}
1075 fi 987 fi
1076 else
1077 if [ ${istar} -eq 1 ] ; then
1078 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1079 | head -c $((${metaskip}-${tailskip})) \
1080 | tar --no-same-owner -xf -
1081 else
1082 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1083 | head -c $((${metaskip}-${tailskip})) \
1084 > ${datafile}
1085 fi
1086 fi
1087 true
1088 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1089 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1090}
1091
1092# Unpack those pesky makeself generated files ...
1093# They're shell scripts with the binary package tagged onto
1094# the end of the archive. Loki utilized the format as does
1095# many other game companies.
1096#
1097# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1098# - If the file is not specified then unpack will utilize ${A}.
1099# - If the offset is not specified then we will attempt to extract
1100# the proper offset from the script itself.
1101unpack_makeself() {
1102 local src_input=${1:-${A}}
1103 local src=$(find_unpackable_file "${src_input}")
1104 local skip=$2
1105 local exe=$3
1106
1107 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1108
1109 local shrtsrc=$(basename "${src}")
1110 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1111 if [[ -z ${skip} ]] ; then
1112 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1113 local skip=0
1114 exe=tail
1115 case ${ver} in 988 case ${size} in
1116 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 989 16|22|24|32|36|48|64|72|96|128|192|256)
1117 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 990 size=${size}x${size};;
1118 ;; 991 scalable)
1119 2.0|2.0.1)
1120 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1121 ;;
1122 2.1.1)
1123 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1124 let skip="skip + 1"
1125 ;;
1126 2.1.2)
1127 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1128 let skip="skip + 1"
1129 ;;
1130 2.1.3)
1131 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1132 let skip="skip + 1"
1133 ;;
1134 2.1.4|2.1.5)
1135 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1136 skip=$(head -n ${skip} "${src}" | wc -c)
1137 exe="dd"
1138 ;; 992 ;;
1139 *) 993 *)
1140 eerror "I'm sorry, but I was unable to support the Makeself file." 994 eerror "${size} is an unsupported icon size!"
1141 eerror "The version I detected was '${ver}'." 995 exit 1;;
1142 eerror "Please file a bug about the file ${shrtsrc} at"
1143 eerror "http://bugs.gentoo.org/ so that support can be added."
1144 die "makeself version '${ver}' not supported"
1145 ;;
1146 esac 996 esac
1147 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 997 shift 2;;
1148 fi 998 -t|--theme)
1149 case ${exe} in 999 theme=${2}
1150 tail) exe="tail -n +${skip} '${src}'";; 1000 shift 2;;
1151 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1001 -c|--context)
1152 *) die "makeself cant handle exe '${exe}'" 1002 context=${2}
1153 esac 1003 shift 2;;
1154
1155 # lets grab the first few bytes of the file to figure out what kind of archive it is
1156 local tmpfile="$(emktemp)"
1157 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1158 local filetype="$(file -b "${tmpfile}")"
1159 case ${filetype} in
1160 *tar\ archive)
1161 eval ${exe} | tar --no-same-owner -xf -
1162 ;;
1163 bzip2*)
1164 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1165 ;;
1166 gzip*)
1167 eval ${exe} | tar --no-same-owner -xzf -
1168 ;;
1169 compress*)
1170 eval ${exe} | gunzip | tar --no-same-owner -xf -
1171 ;;
1172 *) 1004 *)
1173 eerror "Unknown filetype \"${filetype}\" ?"
1174 false
1175 ;;
1176 esac
1177 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1178}
1179
1180# Display a license for user to accept.
1181#
1182# Usage: check_license [license]
1183# - If the file is not specified then ${LICENSE} is used.
1184check_license() {
1185 local lic=$1
1186 if [ -z "${lic}" ] ; then
1187 lic="${PORTDIR}/licenses/${LICENSE}"
1188 else
1189 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1190 lic="${PORTDIR}/licenses/${lic}"
1191 elif [ -e "${PWD}/${lic}" ] ; then
1192 lic="${PWD}/${lic}"
1193 elif [ -e "${lic}" ] ; then
1194 lic="${lic}"
1195 fi
1196 fi
1197 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1198 local l="`basename ${lic}`"
1199
1200 # here is where we check for the licenses the user already
1201 # accepted ... if we don't find a match, we make the user accept
1202 local shopts=$-
1203 local alic
1204 set -o noglob #so that bash doesn't expand "*"
1205 for alic in ${ACCEPT_LICENSE} ; do
1206 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1207 set +o noglob; set -${shopts} #reset old shell opts
1208 return 0
1209 fi
1210 done
1211 set +o noglob; set -$shopts #reset old shell opts
1212
1213 local licmsg="$(emktemp)"
1214 cat << EOF > ${licmsg}
1215**********************************************************
1216The following license outlines the terms of use of this
1217package. You MUST accept this license for installation to
1218continue. When you are done viewing, hit 'q'. If you
1219CTRL+C out of this, the install will not run!
1220**********************************************************
1221
1222EOF
1223 cat ${lic} >> ${licmsg}
1224 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1225 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1226 read alic
1227 case ${alic} in
1228 yes|Yes|y|Y)
1229 return 0
1230 ;;
1231 *)
1232 echo;echo;echo
1233 eerror "You MUST accept the license to continue! Exiting!"
1234 die "Failed to accept license"
1235 ;;
1236 esac
1237}
1238
1239# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1240# the whole 'non-interactive' policy, but damnit I want CD support !
1241#
1242# with these cdrom functions we handle all the user interaction and
1243# standardize everything. all you have to do is call cdrom_get_cds()
1244# and when the function returns, you can assume that the cd has been
1245# found at CDROM_ROOT.
1246#
1247# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1248# etc... if you want to give the cds better names, then just export
1249# the CDROM_NAME_X variables before calling cdrom_get_cds().
1250#
1251# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1252#
1253# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1254# - this will attempt to locate a cd based upon a file that is on
1255# the cd ... the more files you give this function, the more cds
1256# the cdrom functions will handle
1257cdrom_get_cds() {
1258 # first we figure out how many cds we're dealing with by
1259 # the # of files they gave us
1260 local cdcnt=0
1261 local f=
1262 for f in "$@" ; do
1263 ((++cdcnt))
1264 export CDROM_CHECK_${cdcnt}="$f"
1265 done
1266 export CDROM_TOTAL_CDS=${cdcnt}
1267 export CDROM_CURRENT_CD=1
1268
1269 # now we see if the user gave use CD_ROOT ...
1270 # if they did, let's just believe them that it's correct
1271 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1272 local var=
1273 cdcnt=0
1274 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1275 ((++cdcnt))
1276 var="CD_ROOT_${cdcnt}"
1277 [[ -z ${!var} ]] && var="CD_ROOT"
1278 if [[ -z ${!var} ]] ; then 1005 if [[ -z ${size} ]] ; then
1279 eerror "You must either use just the CD_ROOT" 1006 insinto /usr/share/pixmaps
1280 eerror "or specify ALL the CD_ROOT_X variables." 1007 else
1281 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1008 insinto /usr/share/icons/${theme}/${size}/${context}
1282 die "could not locate CD_ROOT_${cdcnt}"
1283 fi 1009 fi
1284 done
1285 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1286 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1287 export CDROM_SET=-1
1288 for f in ${CDROM_CHECK_1//:/ } ; do
1289 ((++CDROM_SET))
1290 [[ -e ${CD_ROOT}/${f} ]] && break
1291 done
1292 export CDROM_MATCH=${f}
1293 return
1294 fi
1295 1010
1296 # User didn't help us out so lets make sure they know they can 1011 if [[ ${funcname} == doicon ]] ; then
1297 # simplify the whole process ...
1298 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1299 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1300 echo
1301 einfo "If you do not have the CD, but have the data files"
1302 einfo "mounted somewhere on your filesystem, just export"
1303 einfo "the variable CD_ROOT so that it points to the"
1304 einfo "directory containing the files."
1305 echo
1306 einfo "For example:"
1307 einfo "export CD_ROOT=/mnt/cdrom"
1308 echo
1309 else
1310 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1311 cdcnt=0
1312 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1313 ((++cdcnt))
1314 var="CDROM_NAME_${cdcnt}"
1315 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1316 done
1317 echo
1318 einfo "If you do not have the CDs, but have the data files"
1319 einfo "mounted somewhere on your filesystem, just export"
1320 einfo "the following variables so they point to the right place:"
1321 einfon ""
1322 cdcnt=0
1323 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1324 ((++cdcnt))
1325 echo -n " CD_ROOT_${cdcnt}"
1326 done
1327 echo
1328 einfo "Or, if you have all the files in the same place, or"
1329 einfo "you only have one cdrom, you can export CD_ROOT"
1330 einfo "and that place will be used as the same data source"
1331 einfo "for all the CDs."
1332 echo
1333 einfo "For example:"
1334 einfo "export CD_ROOT_1=/mnt/cdrom"
1335 echo
1336 fi
1337
1338 export CDROM_SET=""
1339 export CDROM_CURRENT_CD=0
1340 cdrom_load_next_cd
1341}
1342
1343# this is only used when you need access to more than one cd.
1344# when you have finished using the first cd, just call this function.
1345# when it returns, CDROM_ROOT will be pointing to the second cd.
1346# remember, you can only go forward in the cd chain, you can't go back.
1347cdrom_load_next_cd() {
1348 local var
1349 ((++CDROM_CURRENT_CD))
1350
1351 unset CDROM_ROOT
1352 var=CD_ROOT_${CDROM_CURRENT_CD}
1353 [[ -z ${!var} ]] && var="CD_ROOT"
1354 if [[ -z ${!var} ]] ; then 1012 if [[ -f $1 ]] ; then
1355 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1013 doins "${1}"
1356 _cdrom_locate_file_on_cd ${!var} 1014 elif [[ -d $1 ]] ; then
1357 else 1015 shopt -s nullglob
1358 export CDROM_ROOT=${!var} 1016 doins "${1}"/*.{png,svg}
1359 fi 1017 shopt -u nullglob
1360
1361 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1362}
1363
1364# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1365# functions. this should *never* be called from an ebuild.
1366# all it does is try to locate a give file on a cd ... if the cd isn't
1367# found, then a message asking for the user to insert the cdrom will be
1368# displayed and we'll hang out here until:
1369# (1) the file is found on a mounted cdrom
1370# (2) the user hits CTRL+C
1371_cdrom_locate_file_on_cd() {
1372 local mline=""
1373 local showedmsg=0
1374
1375 while [[ -z ${CDROM_ROOT} ]] ; do
1376 local i=0
1377 local -a cdset=(${*//:/ })
1378 if [[ -n ${CDROM_SET} ]] ; then
1379 cdset=(${cdset[${CDROM_SET}]})
1380 fi
1381
1382 while [[ -n ${cdset[${i}]} ]] ; do
1383 local dir=$(dirname ${cdset[${i}]})
1384 local file=$(basename ${cdset[${i}]})
1385
1386 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1387 [[ -d ${mline}/${dir} ]] || continue
1388 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1389 export CDROM_ROOT=${mline}
1390 export CDROM_SET=${i}
1391 export CDROM_MATCH=${cdset[${i}]}
1392 return
1393 fi
1394 done
1395
1396 ((++i))
1397 done
1398
1399 echo
1400 if [[ ${showedmsg} -eq 0 ]] ; then
1401 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1402 if [[ -z ${CDROM_NAME} ]] ; then
1403 einfo "Please insert+mount the cdrom for ${PN} now !"
1404 else 1018 else
1405 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !" 1019 eerror "${1} is not a valid file/directory!"
1020 exit 1
1406 fi 1021 fi
1407 else 1022 else
1408 if [[ -z ${CDROM_NAME_1} ]] ; then 1023 break
1409 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1410 else
1411 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1412 einfo "Please insert+mount the ${!var} cdrom now !"
1413 fi
1414 fi 1024 fi
1415 showedmsg=1 1025 shift 1;;
1416 fi 1026 esac
1417 einfo "Press return to scan for the cd again"
1418 einfo "or hit CTRL+C to abort the emerge."
1419 echo
1420 einfo "If you are having trouble with the detection"
1421 einfo "of your CD, it is possible that you do not have"
1422 einfo "Joliet support enabled in your kernel. Please"
1423 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1424 read || die "something is screwed with your system"
1425 done 1027 done
1028 if [[ ${funcname} == newicon ]] ; then
1029 newins "$@"
1030 fi
1031 ) || die
1426} 1032}
1427 1033
1034# @FUNCTION: doicon
1035# @USAGE: [options] <icons>
1036# @DESCRIPTION:
1037# Install icon into the icon directory /usr/share/icons or into
1038# /usr/share/pixmaps if "--size" is not set.
1039# This is useful in conjunction with creating desktop/menu files.
1040#
1041# @CODE
1042# options:
1043# -s, --size
1044# !!! must specify to install into /usr/share/icons/... !!!
1045# size of the icon, like 48 or 48x48
1046# supported icon sizes are:
1047# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1048# -c, --context
1049# defaults to "apps"
1050# -t, --theme
1051# defaults to "hicolor"
1052#
1053# icons: list of icons
1054#
1055# example 1: doicon foobar.png fuqbar.svg suckbar.png
1056# results in: insinto /usr/share/pixmaps
1057# doins foobar.png fuqbar.svg suckbar.png
1058#
1059# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1060# results in: insinto /usr/share/icons/hicolor/48x48/apps
1061# doins foobar.png fuqbar.png blobbar.png
1062# @CODE
1063doicon() {
1064 _iconins ${FUNCNAME} "$@"
1065}
1066
1067# @FUNCTION: newicon
1068# @USAGE: [options] <icon> <newname>
1069# @DESCRIPTION:
1070# Like doicon, install the specified icon as newname.
1071#
1072# @CODE
1073# example 1: newicon foobar.png NEWNAME.png
1074# results in: insinto /usr/share/pixmaps
1075# newins foobar.png NEWNAME.png
1076#
1077# example 2: newicon -s 48 foobar.png NEWNAME.png
1078# results in: insinto /usr/share/icons/hicolor/48x48/apps
1079# newins foobar.png NEWNAME.png
1080# @CODE
1081newicon() {
1082 _iconins ${FUNCNAME} "$@"
1083}
1084
1085# @FUNCTION: strip-linguas
1086# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1087# @DESCRIPTION:
1428# Make sure that LINGUAS only contains languages that 1088# Make sure that LINGUAS only contains languages that
1429# a package can support 1089# a package can support. The first form allows you to
1430# 1090# specify a list of LINGUAS. The -i builds a list of po
1431# usage: strip-linguas <allow LINGUAS> 1091# files found in all the directories and uses the
1432# strip-linguas -i <directories of .po files> 1092# intersection of the lists. The -u builds a list of po
1433# strip-linguas -u <directories of .po files> 1093# files found in all the directories and uses the union
1434# 1094# of the lists.
1435# The first form allows you to specify a list of LINGUAS.
1436# The -i builds a list of po files found in all the
1437# directories and uses the intersection of the lists.
1438# The -u builds a list of po files found in all the
1439# directories and uses the union of the lists.
1440strip-linguas() { 1095strip-linguas() {
1441 local ls newls 1096 local ls newls nols
1442 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1097 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1443 local op=$1; shift 1098 local op=$1; shift
1444 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1099 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1445 local d f 1100 local d f
1446 for d in "$@" ; do 1101 for d in "$@" ; do
1447 if [[ ${op} == "-u" ]] ; then 1102 if [[ ${op} == "-u" ]] ; then
1448 newls=${ls} 1103 newls=${ls}
1449 else 1104 else
1450 newls="" 1105 newls=""
1451 fi 1106 fi
1452 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1107 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1453 if [[ ${op} == "-i" ]] ; then 1108 if [[ ${op} == "-i" ]] ; then
1454 hasq ${f} ${ls} && newls="${newls} ${f}" 1109 has ${f} ${ls} && newls="${newls} ${f}"
1455 else 1110 else
1456 hasq ${f} ${ls} || newls="${newls} ${f}" 1111 has ${f} ${ls} || newls="${newls} ${f}"
1457 fi 1112 fi
1458 done 1113 done
1459 ls=${newls} 1114 ls=${newls}
1460 done 1115 done
1461 else 1116 else
1462 ls="$@" 1117 ls="$@"
1463 fi 1118 fi
1464 1119
1120 nols=""
1465 newls="" 1121 newls=""
1466 for f in ${LINGUAS} ; do 1122 for f in ${LINGUAS} ; do
1467 if hasq ${f} ${ls} ; then 1123 if has ${f} ${ls} ; then
1468 newls="${newls} ${f}" 1124 newls="${newls} ${f}"
1469 else 1125 else
1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1126 nols="${nols} ${f}"
1471 fi 1127 fi
1472 done 1128 done
1129 [[ -n ${nols} ]] \
1130 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1473 export LINGUAS=${newls:1} 1131 export LINGUAS=${newls:1}
1474} 1132}
1475 1133
1476# moved from kernel.eclass since they are generally useful outside of 1134# @FUNCTION: preserve_old_lib
1477# kernel.eclass -iggy (20041002) 1135# @USAGE: <libs to preserve> [more libs]
1478 1136# @DESCRIPTION:
1479# the following functions are useful in kernel module ebuilds, etc.
1480# for an example see ivtv or drbd ebuilds
1481
1482# set's ARCH to match what the kernel expects
1483set_arch_to_kernel() {
1484 i=10
1485 while ((i--)) ; do
1486 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1487 done
1488 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1489 case ${ARCH} in
1490 x86) export ARCH="i386";;
1491 amd64) export ARCH="x86_64";;
1492 hppa) export ARCH="parisc";;
1493 mips) export ARCH="mips";;
1494 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1495 *) export ARCH="${ARCH}";;
1496 esac
1497}
1498
1499# set's ARCH back to what portage expects
1500set_arch_to_portage() {
1501 i=10
1502 while ((i--)) ; do
1503 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1504 done
1505 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1506}
1507
1508# Jeremy Huddleston <eradicator@gentoo.org>:
1509# preserve_old_lib /path/to/libblah.so.0
1510# preserve_old_lib_notify /path/to/libblah.so.0
1511#
1512# These functions are useful when a lib in your package changes --library. Such 1137# These functions are useful when a lib in your package changes ABI SONAME.
1513# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1138# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1514# would break packages that link against it. Most people get around this 1139# would break packages that link against it. Most people get around this
1515# by using the portage SLOT mechanism, but that is not always a relevant 1140# by using the portage SLOT mechanism, but that is not always a relevant
1516# solution, so instead you can add the following to your ebuilds: 1141# solution, so instead you can call this from pkg_preinst. See also the
1517# 1142# preserve_old_lib_notify function.
1518# src_install() {
1519# ...
1520# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1521# ...
1522# }
1523#
1524# pkg_postinst() {
1525# ...
1526# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1527# ...
1528# }
1529
1530preserve_old_lib() { 1143preserve_old_lib() {
1531 LIB=$1 1144 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1145 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1146 die "Invalid preserve_old_lib() usage"
1147 fi
1148 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1532 1149
1533 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1150 # let portage worry about it
1534 SONAME=`basename ${LIB}` 1151 has preserve-libs ${FEATURES} && return 0
1535 DIRNAME=`dirname ${LIB}`
1536 1152
1537 dodir ${DIRNAME} 1153 local lib dir
1538 cp ${ROOT}${LIB} ${D}${DIRNAME} 1154 for lib in "$@" ; do
1155 [[ -e ${ROOT}/${lib} ]] || continue
1156 dir=${lib%/*}
1157 dodir ${dir} || die "dodir ${dir} failed"
1158 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1539 touch ${D}${LIB} 1159 touch "${D}"/${lib}
1540 fi 1160 done
1541} 1161}
1542 1162
1163# @FUNCTION: preserve_old_lib_notify
1164# @USAGE: <libs to notify> [more libs]
1165# @DESCRIPTION:
1166# Spit helpful messages about the libraries preserved by preserve_old_lib.
1543preserve_old_lib_notify() { 1167preserve_old_lib_notify() {
1544 LIB=$1 1168 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1169 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1170 die "Invalid preserve_old_lib_notify() usage"
1171 fi
1545 1172
1546 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1173 # let portage worry about it
1547 SONAME=`basename ${LIB}` 1174 has preserve-libs ${FEATURES} && return 0
1548 1175
1176 local lib notice=0
1177 for lib in "$@" ; do
1178 [[ -e ${ROOT}/${lib} ]] || continue
1179 if [[ ${notice} -eq 0 ]] ; then
1180 notice=1
1549 ewarn "An old version of an installed library was detected on your system." 1181 ewarn "Old versions of installed libraries were detected on your system."
1550 ewarn "In order to avoid breaking packages that link against it, this older version" 1182 ewarn "In order to avoid breaking packages that depend on these old libs,"
1551 ewarn "is not being removed. In order to make full use of this newer version," 1183 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1552 ewarn "you will need to execute the following command:" 1184 ewarn "in order to remove these old dependencies. If you do not have this"
1553 ewarn " revdep-rebuild --library ${SONAME}" 1185 ewarn "helper program, simply emerge the 'gentoolkit' package."
1554 ewarn 1186 ewarn
1555 ewarn "After doing that, you can safely remove ${LIB}"
1556 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1557 fi 1187 fi
1188 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1189 done
1558} 1190}
1559 1191
1560# Hack for people to figure out if a package was built with 1192# @FUNCTION: built_with_use
1561# certain USE flags 1193# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1194# @DESCRIPTION:
1562# 1195#
1563# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1196# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1564# ex: built_with_use xchat gtk2
1565# 1197#
1566# Flags: -a all USE flags should be utilized 1198# A temporary hack until portage properly supports DEPENDing on USE
1567# -o at least one USE flag should be utilized 1199# flags being enabled in packages. This will check to see if the specified
1568# Note: the default flag is '-a' 1200# DEPEND atom was built with the specified list of USE flags. The
1201# --missing option controls the behavior if called on a package that does
1202# not actually support the defined USE flags (aka listed in IUSE).
1203# The default is to abort (call die). The -a and -o flags control
1204# the requirements of the USE flags. They correspond to "and" and "or"
1205# logic. So the -a flag means all listed USE flags must be enabled
1206# while the -o flag means at least one of the listed IUSE flags must be
1207# enabled. The --hidden option is really for internal use only as it
1208# means the USE flag we're checking is hidden expanded, so it won't be found
1209# in IUSE like normal USE flags.
1210#
1211# Remember that this function isn't terribly intelligent so order of optional
1212# flags matter.
1569built_with_use() { 1213built_with_use() {
1214 local hidden="no"
1215 if [[ $1 == "--hidden" ]] ; then
1216 hidden="yes"
1217 shift
1218 fi
1219
1220 local missing_action="die"
1221 if [[ $1 == "--missing" ]] ; then
1222 missing_action=$2
1223 shift ; shift
1224 case ${missing_action} in
1225 true|false|die) ;;
1226 *) die "unknown action '${missing_action}'";;
1227 esac
1228 fi
1229
1570 local opt=$1 1230 local opt=$1
1571 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1231 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1572 1232
1573 local PKG=$(best_version $1) 1233 local PKG=$(best_version $1)
1234 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1574 shift 1235 shift
1575 1236
1576 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1237 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1238 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1577 1239
1578 # if the USE file doesnt exist, assume the $PKG is either 1240 # if the IUSE file doesn't exist, the read will error out, we need to handle
1579 # injected or package.provided 1241 # this gracefully
1580 [[ ! -e ${USEFILE} ]] && return 0 1242 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1243 case ${missing_action} in
1244 true) return 0;;
1245 false) return 1;;
1246 die) die "Unable to determine what USE flags $PKG was built with";;
1247 esac
1248 fi
1249
1250 if [[ ${hidden} == "no" ]] ; then
1251 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1252 # Don't check USE_EXPAND #147237
1253 local expand
1254 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1255 if [[ $1 == ${expand}_* ]] ; then
1256 expand=""
1257 break
1258 fi
1259 done
1260 if [[ -n ${expand} ]] ; then
1261 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1262 case ${missing_action} in
1263 true) return 0;;
1264 false) return 1;;
1265 die) die "$PKG does not actually support the $1 USE flag!";;
1266 esac
1267 fi
1268 fi
1269 fi
1581 1270
1582 local USE_BUILT=$(<${USEFILE}) 1271 local USE_BUILT=$(<${USEFILE})
1583 while [[ $# -gt 0 ]] ; do 1272 while [[ $# -gt 0 ]] ; do
1584 if [[ ${opt} = "-o" ]] ; then 1273 if [[ ${opt} = "-o" ]] ; then
1585 has $1 ${USE_BUILT} && return 0 1274 has $1 ${USE_BUILT} && return 0
1589 shift 1278 shift
1590 done 1279 done
1591 [[ ${opt} = "-a" ]] 1280 [[ ${opt} = "-a" ]]
1592} 1281}
1593 1282
1283# @FUNCTION: epunt_cxx
1284# @USAGE: [dir to scan]
1285# @DESCRIPTION:
1594# Many configure scripts wrongly bail when a C++ compiler 1286# Many configure scripts wrongly bail when a C++ compiler could not be
1595# could not be detected. #73450 1287# detected. If dir is not specified, then it defaults to ${S}.
1288#
1289# http://bugs.gentoo.org/73450
1596epunt_cxx() { 1290epunt_cxx() {
1597 local dir=$1 1291 local dir=$1
1598 [[ -z ${dir} ]] && dir=${S} 1292 [[ -z ${dir} ]] && dir=${S}
1599 ebegin "Removing useless C++ checks" 1293 ebegin "Removing useless C++ checks"
1600 local f 1294 local f p any_found
1601 for f in $(find ${dir} -name configure) ; do 1295 while IFS= read -r -d '' f; do
1602 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1296 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1297 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1298 any_found=1
1299 break
1300 fi
1603 done 1301 done
1302 done < <(find "${dir}" -name configure -print0)
1303
1304 if [[ -z ${any_found} ]]; then
1305 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1306 fi
1604 eend 0 1307 eend 0
1605} 1308}
1606 1309
1607# dopamd <file> [more files] 1310# @FUNCTION: make_wrapper
1608# 1311# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1609# Install pam auth config file in /etc/pam.d 1312# @DESCRIPTION:
1610dopamd() { 1313# Create a shell wrapper script named wrapper in installpath
1611 [[ -z $1 ]] && die "dopamd requires at least one argument" 1314# (defaults to the bindir) to execute target (default of wrapper) by
1612 1315# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1613 use pam || return 0 1316# libpaths followed by optionally changing directory to chdir.
1614
1615 INSDESTTREE=/etc/pam.d \
1616 doins "$@" || die "failed to install $@"
1617}
1618# newpamd <old name> <new name>
1619#
1620# Install pam file <old name> as <new name> in /etc/pam.d
1621newpamd() {
1622 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1623
1624 use pam || return 0
1625
1626 INSDESTTREE=/etc/pam.d \
1627 newins "$1" "$2" || die "failed to install $1 as $2"
1628}
1629
1630# make a wrapper script ...
1631# NOTE: this was originally games_make_wrapper, but I noticed other places where
1632# this could be used, so I have moved it here and made it not games-specific
1633# -- wolf31o2
1634# $1 == wrapper name
1635# $2 == binary to run
1636# $3 == directory to chdir before running binary
1637# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1638# $5 == path for wrapper
1639make_wrapper() { 1317make_wrapper() {
1640 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1318 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1641 local tmpwrapper=$(emktemp) 1319 local tmpwrapper=$(emktemp)
1320
1321 (
1322 echo '#!/bin/sh'
1323 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${chdir}"
1324 if [[ -n ${libdir} ]] ; then
1325 cat <<-EOF
1326 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1327 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1328 else
1329 export LD_LIBRARY_PATH="${libdir}"
1330 fi
1331 EOF
1332 fi
1642 # We don't want to quote ${bin} so that people can pass complex 1333 # We don't want to quote ${bin} so that people can pass complex
1643 # things as $bin ... "./someprog --args" 1334 # things as ${bin} ... "./someprog --args"
1335 printf 'exec %s "$@"\n' "${bin}"
1644 cat << EOF > "${tmpwrapper}" 1336 ) > "${tmpwrapper}"
1645#!/bin/sh
1646cd "${chdir:-.}"
1647if [ -n "${libdir}" ] ; then
1648 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1649 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1650 else
1651 export LD_LIBRARY_PATH="${libdir}"
1652 fi
1653fi
1654exec ${bin} "\$@"
1655EOF
1656 chmod go+rx "${tmpwrapper}" 1337 chmod go+rx "${tmpwrapper}"
1338
1657 if [[ -n ${path} ]] ; then 1339 if [[ -n ${path} ]] ; then
1340 (
1658 exeinto "${path}" 1341 exeinto "${path}"
1659 newexe "${tmpwrapper}" "${wrapper}" 1342 newexe "${tmpwrapper}" "${wrapper}"
1343 ) || die
1660 else 1344 else
1661 newbin "${tmpwrapper}" "${wrapper}" 1345 newbin "${tmpwrapper}" "${wrapper}" || die
1346 fi
1347}
1348
1349# @FUNCTION: path_exists
1350# @USAGE: [-a|-o] <paths>
1351# @DESCRIPTION:
1352# Check if the specified paths exist. Works for all types of paths
1353# (files/dirs/etc...). The -a and -o flags control the requirements
1354# of the paths. They correspond to "and" and "or" logic. So the -a
1355# flag means all the paths must exist while the -o flag means at least
1356# one of the paths must exist. The default behavior is "and". If no
1357# paths are specified, then the return value is "false".
1358path_exists() {
1359 local opt=$1
1360 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1361
1362 # no paths -> return false
1363 # same behavior as: [[ -e "" ]]
1364 [[ $# -eq 0 ]] && return 1
1365
1366 local p r=0
1367 for p in "$@" ; do
1368 [[ -e ${p} ]]
1369 : $(( r += $? ))
1370 done
1371
1372 case ${opt} in
1373 -a) return $(( r != 0 )) ;;
1374 -o) return $(( r == $# )) ;;
1375 esac
1376}
1377
1378# @FUNCTION: in_iuse
1379# @USAGE: <flag>
1380# @DESCRIPTION:
1381# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1382# as necessary.
1383#
1384# Note that this function should not be used in the global scope.
1385in_iuse() {
1386 debug-print-function ${FUNCNAME} "${@}"
1387 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1388
1389 local flag=${1}
1390 local liuse=( ${IUSE} )
1391
1392 has "${flag}" "${liuse[@]#[+-]}"
1393}
1394
1395# @FUNCTION: use_if_iuse
1396# @USAGE: <flag>
1397# @DESCRIPTION:
1398# Return true if the given flag is in USE and IUSE.
1399#
1400# Note that this function should not be used in the global scope.
1401use_if_iuse() {
1402 in_iuse $1 || return 1
1403 use $1
1404}
1405
1406# @FUNCTION: usex
1407# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1408# @DESCRIPTION:
1409# Proxy to declare usex for package managers or EAPIs that do not provide it
1410# and use the package manager implementation when available (i.e. EAPI >= 5).
1411# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1412# otherwise echo [false output][false suffix] (defaults to "no").
1413if has "${EAPI:-0}" 0 1 2 3 4; then
1414 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1415fi
1416
1417# @FUNCTION: prune_libtool_files
1418# @USAGE: [--all|--modules]
1419# @DESCRIPTION:
1420# Locate unnecessary libtool files (.la) and libtool static archives
1421# (.a) and remove them from installation image.
1422#
1423# By default, .la files are removed whenever the static linkage can
1424# either be performed using pkg-config or doesn't introduce additional
1425# flags.
1426#
1427# If '--modules' argument is passed, .la files for modules (plugins) are
1428# removed as well. This is usually useful when the package installs
1429# plugins and the plugin loader does not use .la files.
1430#
1431# If '--all' argument is passed, all .la files are removed without
1432# performing any heuristic on them. You shouldn't ever use that,
1433# and instead report a bug in the algorithm instead.
1434#
1435# The .a files are only removed whenever corresponding .la files state
1436# that they should not be linked to, i.e. whenever these files
1437# correspond to plugins.
1438#
1439# Note: if your package installs both static libraries and .pc files
1440# which use variable substitution for -l flags, you need to add
1441# pkg-config to your DEPEND.
1442prune_libtool_files() {
1443 debug-print-function ${FUNCNAME} "$@"
1444
1445 local removing_all removing_modules opt
1446 for opt; do
1447 case "${opt}" in
1448 --all)
1449 removing_all=1
1450 removing_modules=1
1451 ;;
1452 --modules)
1453 removing_modules=1
1454 ;;
1455 *)
1456 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1457 esac
1458 done
1459
1460 local f
1461 local queue=()
1462 while IFS= read -r -d '' f; do # for all .la files
1463 local archivefile=${f/%.la/.a}
1464
1465 # The following check is done by libtool itself.
1466 # It helps us avoid removing random files which match '*.la',
1467 # see bug #468380.
1468 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1'; then
1469 continue
1662 fi 1470 fi
1471
1472 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1473 local reason pkgconfig_scanned
1474 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1475
1476 if [[ ${snotlink} == yes ]]; then
1477
1478 # Remove static libs we're not supposed to link against.
1479 if [[ -f ${archivefile} ]]; then
1480 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1481 queue+=( "${archivefile}" )
1482 fi
1483
1484 # The .la file may be used by a module loader, so avoid removing it
1485 # unless explicitly requested.
1486 if [[ ${removing_modules} ]]; then
1487 reason='module'
1488 fi
1489
1490 else
1491
1492 # Remove .la files when:
1493 # - user explicitly wants us to remove all .la files,
1494 # - respective static archive doesn't exist,
1495 # - they are covered by a .pc file already,
1496 # - they don't provide any new information (no libs & no flags).
1497
1498 if [[ ${removing_all} ]]; then
1499 reason='requested'
1500 elif [[ ! -f ${archivefile} ]]; then
1501 reason='no static archive'
1502 elif [[ ! $(sed -nre \
1503 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1504 "${f}") ]]; then
1505 reason='no libs & flags'
1506 else
1507 if [[ ! ${pkgconfig_scanned} ]]; then
1508 # Create a list of all .pc-covered libs.
1509 local pc_libs=()
1510 if [[ ! ${removing_all} ]]; then
1511 local pc
1512 local tf=${T}/prune-lt-files.pc
1513 local pkgconf=$(tc-getPKG_CONFIG)
1514
1515 while IFS= read -r -d '' pc; do # for all .pc files
1516 local arg libs
1517
1518 # Use pkg-config if available (and works),
1519 # fallback to sed.
1520 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1521 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1522 libs=$(${pkgconf} --libs "${tf}")
1523 else
1524 libs=$(sed -ne 's/^Libs://p' "${pc}")
1525 fi
1526
1527 for arg in ${libs}; do
1528 if [[ ${arg} == -l* ]]; then
1529 if [[ ${arg} == '*$*' ]]; then
1530 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1531 eqawarn "(arg: ${arg})"
1532 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1533 fi
1534
1535 pc_libs+=( lib${arg#-l}.la )
1536 fi
1537 done
1538 done < <(find "${D}" -type f -name '*.pc' -print0)
1539
1540 rm -f "${tf}"
1541 fi
1542
1543 pkgconfig_scanned=1
1544 fi # pkgconfig_scanned
1545
1546 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1547 fi # removal due to .pc
1548
1549 fi # shouldnotlink==no
1550
1551 if [[ ${reason} ]]; then
1552 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1553 queue+=( "${f}" )
1554 fi
1555 done < <(find "${D}" -xtype f -name '*.la' -print0)
1556
1557 if [[ ${queue[@]} ]]; then
1558 rm -f "${queue[@]}"
1559 fi
1663} 1560}
1561
1562check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1563
1564fi

Legend:
Removed from v.1.237  
changed lines
  Added in v.1.420

  ViewVC Help
Powered by ViewVC 1.1.20